using System.Linq.Expressions;
using IQToolkit.Data.Common;

namespace LinqToVfp {
    internal partial class VfpExecutionBuilder {
        private class ProjectionFinder : VfpExpressionVisitor {
            private ProjectionExpression found = null;

            internal static ProjectionExpression FindProjection(Expression expression) {
                var finder = new ProjectionFinder();
                finder.Visit(expression);
                return finder.found;
            }

            protected override Expression VisitProjection(ProjectionExpression proj) {
                this.found = proj;
                return proj;
            }
        }
    }
}